﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;
using HeuristicLab.Problems.BinPacking.Shapes;

namespace HeuristicLab.Problems.BinPacking.Views {
  [View("View for a cuboid shape.")]
  [Content(typeof(CuboidPackingShape), true)]
  public partial class CuboidPackingShapeView : NamedItemView {
    public CuboidPackingShapeView() {
      InitializeComponent();
    }


    public new CuboidPackingShape Content {
      get { return (CuboidPackingShape)base.Content; }
      set { base.Content = value; }
    }


    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        Redraw();
      } else {
        Redraw(Content);
        Content.Name = "XX";
        packingPlan3D1.StartRendering();
      }
    }


    private void Redraw() {
      packingPlan3D1.InitializeContainer(0,0,0);
    }

    private void Redraw(CuboidPackingShape shape) {
      packingPlan3D1.InitializeContainer(shape.Width, shape.Height, shape.Depth);
    }
  }
}
